package com.commonsware.android.hurl.secure;

import android.media.AudioManager;
import android.media.ToneGenerator;
import android.util.Log;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;

public class DownloadThread extends Thread {
  private static final String HTTP="http://wares-nossl.commonsware.com";
  private final File output;
  final private ToneGenerator beeper=
    new ToneGenerator(AudioManager.STREAM_NOTIFICATION, 100);

  DownloadThread(File output) {
    this.output=output;
  }

  @Override
  public void run() {
    try {
      URL url=new URL(HTTP);
      HttpURLConnection c=(HttpURLConnection)url.openConnection();
      FileOutputStream fos=new FileOutputStream(output.getPath());
      BufferedOutputStream out=new BufferedOutputStream(fos);
      String mimeType=c.getHeaderField("Content-type");
      InputStream in=c.getInputStream();
      byte[] buffer=new byte[16384];
      int len=0;

      while ((len=in.read(buffer)) >= 0) {
        out.write(buffer, 0, len);
      }

      out.flush();
      fos.getFD().sync();
      out.close();
      c.disconnect();
      beeper.startTone(ToneGenerator.TONE_PROP_ACK);
      Log.d("HURLSecure", "Downloaded content with MIME type: "+mimeType);
    }
    catch (Exception e) {
      Log.e("HURLSecure", "Exception trying to download content", e);
      beeper.startTone(ToneGenerator.TONE_PROP_NACK);
    }
  }
}
